<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaPageteaser\Xclass\Templavoila;

/**
 * @package     imia_pageteaser
 * @subpackage  Xclass
 * @author      David Frerich <d.frerich@imia.de>
 */
class SpecialDoktypes extends \tx_templavoila_mod1_specialdoktypes
{
    /**
     * @param array $pageRecord
     * @return mixed
     */
    public function renderDoktype_103($pageRecord)
    {
        return self::renderDoktype_3($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return mixed
     */
    public function renderDoktype_104($pageRecord)
    {
        return self::renderDoktype_4($pageRecord);
    }

	/**
	 * Displays the edit page screen if the currently selected page is of the doktype "Images"
	 *
	 * @param	array		$pageRecord: The current page record
	 * @return	mixed		HTML output from this submodule or FALSE if this submodule doesn't feel responsible
	 * @access	public
	 */
	function renderDoktype_111($pageRecord)
    {
		global $LANG, $BE_USER, $TYPO3_CONF_VARS;

        // Prepare the record icon including a content sensitive menu link wrapped around it:
		$recordIcon = \TYPO3\CMS\Backend\Utility\IconUtility::getSpriteIconForRecord('pages', $pageRecord);
		$iconEdit = \TYPO3\CMS\Backend\Utility\IconUtility::getSpriteIcon('actions-document-open', array('title' => htmlspecialchars($LANG->sL('LLL:EXT:lang/locallang_mod_web_list.xml:editPage'))));
		$editButton = $this->pObj->link_edit($iconEdit, 'pages', $pageRecord['uid']);

        $notice = 'Diese Seite ist eine Bilder-Galerie und enthält keine eigenen Inhaltselemente. Daher können Sie den Inhalt dieser Seite nicht direkt bearbeiten.';

		$flashMessage = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(
			't3lib_FlashMessage',
			$notice,
			'',
			\TYPO3\CMS\Core\Messaging\FlashMessage::INFO
		);

		$content = $flashMessage->render();

		return $content;
	}

	/**
	 * Displays the edit page screen if the currently selected page is of the doktype "Images"
	 *
	 * @param	array		$pageRecord: The current page record
	 * @return	mixed		HTML output from this submodule or FALSE if this submodule doesn't feel responsible
	 * @access	public
	 */
	function renderDoktype_112($pageRecord)
    {
		global $LANG, $BE_USER, $TYPO3_CONF_VARS;

        // Prepare the record icon including a content sensitive menu link wrapped around it:
		$recordIcon = \TYPO3\CMS\Backend\Utility\IconUtility::getSpriteIconForRecord('pages', $pageRecord);
		$iconEdit = \TYPO3\CMS\Backend\Utility\IconUtility::getSpriteIcon('actions-document-open', array('title' => htmlspecialchars($LANG->sL('LLL:EXT:lang/locallang_mod_web_list.xml:editPage'))));
		$editButton = $this->pObj->link_edit($iconEdit, 'pages', $pageRecord['uid']);

        $notice = 'Diese Seite ist ein Video und enthält keine eigenen Inhaltselemente. Daher können Sie den Inhalt dieser Seite nicht direkt bearbeiten.';

		switch ($pageRecord['urltype']) {
			case 4:
				$url = 'https://' . $pageRecord['url'];
			break;
			default:
                // Check if URI scheme already present. We support only Internet-specific notation,
                // others are not relevant for us (see http://www.ietf.org/rfc/rfc3986.txt for details)
				if (preg_match('/^[a-z]+[a-z0-9\+\.\-]*:\/\//i', $pageRecord['url'])) {
                    // Do not add any other scheme
					$url = $pageRecord['url'];
					break;
				}
				// fall through
			case 1:
				$url = 'http://' . $pageRecord['url'];
			break;
		}

        $urlInfo = ' <br /><br /><strong><a href="' . $url . '" target="_new">' . htmlspecialchars(sprintf('Zum externen Video springen (%s) ', $url)) . '</a></strong>';
		$flashMessage = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(
			't3lib_FlashMessage',
			$notice,
			'',
			\TYPO3\CMS\Core\Messaging\FlashMessage::INFO
		);

		$content = $flashMessage->render() . $urlInfo;

		return $content;
	}

    /**
     * @param array $pageRecord
     * @return mixed
     */
    public function renderDoktype_113($pageRecord)
    {
        return self::renderDoktype_3($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return mixed
     */
    public function renderDoktype_114($pageRecord)
    {
        return self::renderDoktype_4($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return mixed
     */
    public function renderDoktype_123($pageRecord)
    {
        return self::renderDoktype_3($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return mixed
     */
    public function renderDoktype_124($pageRecord)
    {
        return self::renderDoktype_4($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return mixed
     */
    public function renderDoktype_133($pageRecord)
    {
        return self::renderDoktype_3($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return mixed
     */
    public function renderDoktype_134($pageRecord)
    {
        return self::renderDoktype_4($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return mixed
     */
    public function renderDoktype_143($pageRecord)
    {
        return self::renderDoktype_3($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return mixed
     */
    public function renderDoktype_144($pageRecord)
    {
        return self::renderDoktype_4($pageRecord);
    }
}