<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

if (!defined('TYPO3_MODE')) {
    die('Access denied.');
}

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
    'IMIA.' . $_EXTKEY,
    'teaser',
    'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/Plugin.xlf:teaser'
);
\IMIA\BaseExt\Utility\ExtensionUtility::registerPluginFlexform($_EXTKEY, 'teaser', 'Configuration/FlexForms/Teaser.xml');

$GLOBALS['TCA']['tt_content']['ctrl']['requestUpdate'] =
    $GLOBALS['TCA']['tt_content']['ctrl']['requestUpdate'] ? $GLOBALS['TCA']['tt_content']['ctrl']['requestUpdate'] .
    ',settings.displayType' : 'settings.displayType';

$doktypes = array(
    100 => 'News',
    110 => 'Gallery',
    120 => 'Product',
    130 => 'Event',
    140 => 'Article',
);

$standardDoktypes = $shortcutDoktypes = array();
foreach ($doktypes as $doktype => $name) {
    \TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon('pages', $doktype,
        \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) .
        'Resources/Public/Images/Icons/PageDoktype' . $name . '.png');

    \TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon('pages', $doktype + 3,
        \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) .
        'Resources/Public/Images/Icons/PageDoktype' . $name . 'External.png');

    \TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon('pages', $doktype + 4,
        \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) .
        'Resources/Public/Images/Icons/PageDoktype' . $name . 'Shortcut.png');

    $standardDoktypes[] = $doktype;
    $shortcutDoktypes[] = $doktype + 3;
    $shortcutDoktypes[] = $doktype + 4;

    if ($doktype === 110) {
        $specialDoktypes[] = $doktype + 1;
        $specialDoktypes[] = $doktype + 2;

        \TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon('pages', $doktype + 1,
            \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) .
                'Resources/Public/Images/Icons/PageDoktype' . $name . 'Images.png');

        \TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon('pages', $doktype + 2,
            \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) .
                'Resources/Public/Images/Icons/PageDoktype' . $name . 'Video.png');
    }
}

$allDoktypes = array_merge($standardDoktypes, $shortcutDoktypes, $specialDoktypes);
foreach ($standardDoktypes as $doktype) {
    $GLOBALS['PAGES_TYPES'][$doktype] = array(
        'allowedTables' => '*',
        'onlyAllowedTables' => ''
    );
}
foreach ($shortcutDoktypes as $doktype) {
    $GLOBALS['PAGES_TYPES'][$doktype] = array(
        'allowedTables' => '*',
        'onlyAllowedTables' => ''
    );
}

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPageTSConfig('
    TCAdefaults.pages.lastUpdated = ' . time() . '
    TCEFORM {
        pages {
            doktype.removeItems = ' . implode(',', $allDoktypes) . '
            teaser_image.disabled = 1
            teaser_pages.disabled = 1
        }
        pages_language_overlay {
            doktype.removeItems = ' . implode(',', $allDoktypes) . '
            teaser_image.disabled = 1
        }
    }

    [page|doktype = ' . implode('] || [page|doktype = ', $allDoktypes) . ']
        TCEFORM {
            pages {
                teaser_image.disabled = 0
                lastUpdated.label = LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/DB.xlf:page_lastupdated
            }
            pages_language_overlay {
                teaser_image.disabled = 0
            }
        }
    [end]
');

$GLOBALS['TCA']['pages']['columns']['content_from_pid']['displayCond'] = array(
    'OR' => array(
        'FIELD:mount_pid_ol:REQ:false',
        'FIELD:doktype:!=:7',
    ),
);
$GLOBALS['TCA']['pages']['ctrl']['requestUpdate'] .= ',mount_pid_ol';
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes('pages', 'content_from_pid', '7', 'after:mount_pid');